/*	======================
 *	AEAAppleEventSender.hh
 *	======================
 */

#pragma once

// Mac Universal Headers
#include <AppleEvents.h>
#include <EPPC.h>

#include "AEADescAppleEvent.hh"

class AEAAppleEventSender {
public:
	AEAAppleEventSender(AEEventClass inEventClass, AEEventID inEventID);
	AEAAppleEventSender(AEEventClass inEventClass, AEEventID inEventID,
		AEIdleUPP &inAEIdleUPP);
	virtual ~AEAAppleEventSender();
	
	virtual void SetAddress(const ProcessSerialNumber &inPSN);
	virtual void SetAddress(const OSType inSignature);
	virtual void SetAddress(const TargetID &inTargetID);
	virtual void SetGizmoBuildString(const char *inString);
	virtual void Build();
	virtual void Send();
	virtual void SendAndWaitForReply(AppleEvent &outReply);
	virtual void SendAndWaitForReply(AEADescAppleEvent &outReply);
protected:
	AEEventClass mEventClass;
	AEEventID mEventID;
	AEIdleUPP mAEIdleUPP; // default AEIdle function for sending Apple events
	AEAddressDesc mAddress;
	char *mGizmoBuildString;
	AppleEvent mAppleEvent;
};
