/*	==============
 *	AEADescList.hh
 *	==============
 *	
 *	Implemented by AEADescList.cc
 */

#pragma once

#include "AEADesc.hh"

class AEADescList : virtual public AEADesc {
public:
	AEADescList();
	AEADescList(AEDesc inAEDesc);
	AEADescList(const void *inFactoringPtr, Size inFactoredSize);
	virtual ~AEADescList();
	
	virtual void Create();
	virtual void Create(const void *inFactoringPtr, Size inFactoredSize);
	
	virtual long CountItems() const;
	virtual void Get(long inIndex, DescType inDesiredType, 
		void *outDataPtr, Size inMaximumSize, Size &outActualSize) const;
	virtual void Get(long inIndex, AEDesc &outAEDesc) const;
	
	virtual void Put(long inIndex, DescType inTypeCode, 
		const void *inDataPtr, Size inDataSize);
	virtual void Put(long inIndex, const AEDesc &inAEDesc);
	//virtual void Put(long inIndex, const AEADesc &inDesc);
	virtual void Put(AEArrayType inArrayType, const AEArrayDataPointer inArrayPtr, 
		DescType inItemType, Size inItemSize, long inItemCount);
protected:
	//virtual void InternalCreate(const void *inFactoringPtr, Size inFactoredSize);
};
