/*	===============
 *	AEAModelName.cc
 *	===============
 */

#include "AEADebugging.h"

#include <string.h>

#include "AEADesc.hh"

#include "AEAModelName.hh"

AEAModelName::AEAModelName(const AEAModel &inContainer, const char *inStr)
: AEAModelProperty(inContainer, pName)
{
	mSize = strlen(inStr);
	mData = new char [mSize];
	memcpy(mData, inStr, mSize);
}

AEAModelName::AEAModelName(const AEAModel &inContainer, const unsigned char *inStr)
: AEAModelProperty(inContainer, pName)
{
	mSize = inStr[0];
	mData = new char [mSize];
	memcpy(mData, (const char *)&inStr[1], mSize);
}

AEAModelName::~AEAModelName()
{
	delete [] mData;
}

void
AEAModelName::MakeDescriptor(AEDesc &outAEDesc) const
{
	AEADesc desc;
	desc.Create(typeChar, mData, mSize);
	outAEDesc = desc.Ref();
	desc.Reset();
}
