/*	============
 *	C3DMatrix.hh
 *	============
 *	
 *	Implemented by C3DMatrix.cc
 */

#ifndef C3DMATRIX_HH
#define C3DMATRIX_HH

class C3DMatrix {
public:
	C3DMatrix(short inHeight, short inWidth);
	C3DMatrix(const C3DMatrix &inMatrix);
	virtual ~C3DMatrix();
	
	virtual C3DMatrix &operator=(const C3DMatrix &inMatrix);
	
	virtual double &Cell(short inRow, short inCol);
	virtual const double &Cell(short inRow, short inCol) const;
	virtual void Multiply(const C3DMatrix &inFactor, C3DMatrix &outProduct) const;
	virtual C3DMatrix *Times(const C3DMatrix &inFactor) const;
	virtual C3DMatrix &MultiplyBy(const C3DMatrix &inFactor);
	virtual C3DMatrix &ConverselyMultiplyBy(const C3DMatrix &inFactor);
	
protected:
	short mHeight, mWidth;
	double *mData;
};

#endif
