/*	=============
 *	GenieShell.hh
 *	=============
 *	
 *	Implemented by GenieShell.cc
 */

#pragma once

#include "NGLList.hh"
#include "PedTask.hh"
#include "PedFSRef.hh"

class SiesString;
class GenieVariable;
class GenieConsole;

class GenieShell : public PedTask {
public:
	GenieShell(PedTask *inParent, GenieConsole &inConsole);
	virtual ~GenieShell();
	
	virtual long ExecuteCmdLine(const SiesString &inCmd);
	virtual long ExecuteArgs(long argC, char **argV);
	virtual long ChangeDirectory(const char *inPathname);
	
protected:
	GenieConsole &mConsole;
	NGLList<GenieVariable *> mLocalVars;  // local shell variables
	PedFSRef mCwd;
};

class GenieVariable {
public:
	GenieVariable();
	virtual ~GenieVariable();
	
};
