/* mkdir.c */

#include <stdio.h>

#include <Errors.h>

#include "MoreFilesExtras.h"
#include "pstring.h"
#include "SiesString.hh"
#include "pathnames.hh"

#define NAM

#ifdef NAM
extern "C" int mkdir_main(int argc, char *argv[]);
#else
#define mkdir_main main
#endif

static int TryHFSDirCreate(
	short vol, long dir, const unsigned char *name);
	
int mkdir_main(int argc, char *argv[])
{
	OSErr err;
	FSDirSpec cwdir = {0, 0, 0}, *cwdp;
	FSDirSpec srcDir;
	Str31 dirName;
	SiesString strDirName;
	int index, fail;
	
	// Current working directory: either passed 'under the table' or set to default.
	cwdp = (argv[-1] != NULL) ? (FSDirSpec *)argv[-1] : (&cwdir);
	
	// Check for sufficient number of args
	if (argc < 2) {
		fprintf(stderr, "mkdir: missing arguments\n");
		return 1;
	}
	
	// Try to make each directory.  Return whether any errors occurred.
	fail = 0;
	for (index = 1; index < argc; index++) {
		err = UnixRelativePathname2DirAndName(*cwdp, argv[index], srcDir, strDirName);
		if (err != fnfErr) {
			fprintf(stderr, "mkdir: %s: %s\n", argv[index], (err == noErr ? "already exists" : "nonexistent directory in pathname"));
			fail++;
		} else {
			strDirName.GetPStr(dirName, 31);
			fail += TryHFSDirCreate(srcDir.vRefNum, srcDir.dirID, dirName);
		}
	}
	return (fail == 0) ? 0 : 1;
}

int TryHFSDirCreate(
	short vol, long dir, const unsigned char *inName)
{
	OSErr err;
	//Str255 nameStr;
	Boolean isDir;
	
	//Pstrcpy(nameStr, name);
	err = DirCreate(vol, dir, inName, &dir);
	if (err != noErr) {
		char name[32];
		strPcpy(name, inName);
		fprintf(stderr, "mkdir: %s: %s %d\n", name, "DirCreate error", err);
		return 1;
	}
	return 0;
}
