/* pwd.c */

#include <stdio.h>

#include "MoreFilesExtras.h"
#include "pstring.h"
#include "pathnames.hh"

#define NAM

#ifdef NAM
extern "C" int pwd_main(int argc, char *argv[]);
#else
#define pwd_main main
#endif

int pwd_main(int argc, char *argv[])
{
	OSErr err;
	FSDirSpec cwdir = {0, 0, 0}, *cwdp;
	Handle pathname;
	
	// Current working directory: either passed 'under the table' or set to default.
	cwdp = (argv[-1] != NULL) ? (FSDirSpec *)argv[-1] : (&cwdir);
	pathname = NewHandle(0);
	err = DirAndName2UnixAbsolutePathname(cwdp, NULL, pathname);
	if (err != noErr) {
		fprintf(stderr, "pwd: %s %d\n", "OS error", err);
		DisposeHandle(pathname);
		return 1;
	}
	HLock(pathname);
	fprintf(stdout, "%s\n", *pathname);
	DisposeHandle(pathname);
	
	return 0;
}
