/*	=============
 *	PedControl.hh
 *	=============
 *	
 *	Implemented by PedControl.cc
 */

#pragma once

#include <Controls.h>

#include "PedPane.hh"


class PedControl : public PedPane {
public:
	PedControl(PedView &inSuperView);
	virtual ~PedControl();
	
	virtual void Init();
	
	virtual void Open();
	virtual void Close();
	
	// Pane management
	virtual short Minimum();
	virtual void SetMinimum(short inMin);
	virtual short Maximum();
	virtual void SetMaximum(short inMax);
	virtual short Value();
	virtual void SetValue(short inVal);
	virtual void Activate();
	virtual void Deactivate();
	virtual void Resize(short inWidth, short inHeight);
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	
protected:
	virtual void Draw();
	
	ControlHandle macControl;
};
