/*	=================
 *	PedPaneSubView.hh
 *	=================
 *	
 *	Implemented by PedPaneSubView.cc
 */

#pragma once

#include "PedPane.hh"
#include "PedViewSub.hh"

class PedPaneSubView : public PedPane {
public:
	PedPaneSubView(PedView &inSuperView);
	virtual ~PedPaneSubView();
	
	virtual void Dispose();
	
	virtual PedView &SuperView();
	
	virtual void SetSubView(PedViewSub *inView);
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	
	virtual void Resize(short inWidth, short inHeight);
	virtual void DrawContent();
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
	PedViewSub *mSubView;
};
