/*	============
 *	PedPaneTE.hh
 *	============
 *	
 *	Implemented by PedPaneTE.cc
 */

#pragma once

#include <TextEdit.h>

#include "PedPane.hh"

class PedPaneTE : public PedPane {
public:
	PedPaneTE(PedView &inSuperView);
	virtual ~PedPaneTE();
	
	virtual void GetBounds(Rect &outBounds);
	virtual void SetBounds(const Rect &inBounds);
	virtual void GetScrollPos(Point &outPos);
	virtual void NotifyIfScrolled(Point inOldPos);
	
	virtual void Init();
	
	virtual void Open();
	virtual void Close();
	
	// Pane management
	virtual void Activate();
	virtual void Deactivate();
	virtual void Resize(short inWidth, short inHeight);
	virtual void Scroll(short inH, short inV, bool inUpdate);
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	virtual void DoKey(char inChar);
	
	// Text manipulation
	virtual short TextLength() {return macTE ? (*macTE)->teLength : 0;}
	virtual Handle TextHandle() {return macTE ? (*macTE)->hText : NULL;}
	virtual void GetSelection(long *outStart, long *outEnd);
	virtual void SetSelection(short inStart, short inEnd);
	virtual long AppendChars(char *buffer, long n);
	
	virtual void Cut();
	virtual void Copy();
	virtual void Paste();
	virtual void Clear();
	
protected:
	virtual void Draw();
	
	TEHandle macTE;
};
