/*	==========
 *	PedView.hh
 *	==========
 *	
 *	Implemented by PedView.cc
 */

#pragma once

#include <Events.h>
#include <Types.h>

#include "PedObject.hh"

class PedWindow;

class PedView : public PedObject {
public:
	PedView();
	virtual ~PedView();
	
	virtual bool IsInExistence() {return false;}
	virtual void GetFrame(Rect &outFrame) = 0;
	virtual PedWindow &Window() = 0;
	virtual void GetWindowToFrameOffset(Point &outOffset);
	virtual void GetWindowToLocalOffset(Point &outOffset);
	
	virtual void Focus();
	virtual void Activate();
	virtual void Deactivate();
	virtual void Refresh();
	virtual void DrawContent();
	virtual void Resize(short inWidth, short inHeight);
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
};

#if 0
class UPedNullView : public PedView {
public:
	UPedNullView() : PedView(*this) {}
	virtual void Focus() {}
};

extern UPedNullView gNullView;
#endif
