/*	===================
 *	PedViewMultipane.hh
 *	===================
 *	
 *	Implemented by PedViewMultipane.cc
 */

#pragma once

#include "NGLList.hh"

#include "PedViewSub.hh"

class PedPane;
class PedPaneSubView;

class PedViewMultipane : public PedViewSub {
public:
	PedViewMultipane(PedPaneSubView &inSuperPane);
	virtual ~PedViewMultipane();
	
	virtual void AddPane(PedPane *inPane);
	virtual void RemovePane(PedPane *inPane);
	
	virtual void Focus();
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	
	virtual void Resize(short inWidth, short inHeight);
	virtual void DrawContent();
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
	NGLList<PedPane *> mPanes;
};
