/*	==================
 *	PedViewScroller.hh
 *	==================
 *	
 *	Implemented by PedViewScroller.cc
 */

#pragma once

#include "PedViewSub.hh"

class PedPane;
class PedScrollbar;

class PedViewScroller : public PedViewSub {
public:
	PedViewScroller(PedPaneSubView &inSuperPane);
	virtual ~PedViewScroller();
	
	virtual void Dispose();
	
	virtual void GetFrame(Rect &outFrame);
	virtual void GetAperture(Rect &outAperture) = 0;
	virtual void GetScrollPos(Point &outPos) = 0;
	virtual void SetScrollbarPresence(short inAxis, bool inPresent);
	virtual PedPane *Pane() = 0;
	
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	
	virtual void Resize(short inWidth, short inHeight);
	virtual void Calibrate();
	virtual void DrawContent();
	virtual long Message(long inMsgCode, void *inData);
	virtual void NotifyScrolledTo(short inH, short inV);
	virtual void Scroll(short inH, short inV, bool inUpdate) = 0;
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
	virtual PedPane *MyPane() = 0;
	
protected:
	PedScrollbar *mScrollV, *mScrollH;
};
