/*	=============
 *	PedViewSub.hh
 *	=============
 *	
 *	Implemented by PedViewSub.cc
 */

#pragma once

#include "PedView.hh"

#if 0
class CPedGrafPort {
public:
	CPedGrafPort() {::OpenPort(&macPort);}
	virtual ~CPedGrafPort() {::ClosePort(&macPort);}
	
	virtual void Set() {::SetPort(&macPort);}
	virtual void SetPortSize(short inWidth, short inHeight) {Set(); ::PortSize(inWidth, inHeight);}
	virtual void MovePortTo(short inLeft, short inTop) {Set(); ::MovePortTo(inLeft, inTop);}
	virtual void SetOrigin(short inH, short inV) {Set(); ::SetOrigin(inH, inV);}
	virtual void ClipRect(const Rect &inRect) {Set(); ::ClipRect(&inRect);}
	
protected:
	GrafPort macPort;
};
#endif

class PedPane;
class PedPaneSubView;

class PedViewSub : public PedView {
public:
	PedViewSub(PedPaneSubView &inSuperPane);
	virtual ~PedViewSub();
	
	virtual void Dispose() = 0;
	
	virtual PedPaneSubView &SuperPane();
	virtual void GetFrame(Rect &outFrame);
	virtual void GetOrigin(Point &outOrigin);
	virtual void SetOrigin(Point inOrigin);
	virtual PedWindow &Window();
	virtual void GetWindowToFrameOffset(Point &outOffset);
	
	virtual void Focus();
	virtual void Open();
	virtual void Close();
	virtual void Activate();
	virtual void Deactivate();
	virtual void Refresh();
	
	virtual void Resize(short inWidth, short inHeight);
	virtual void DrawContent() = 0;
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	
protected:
	PedPaneSubView &mSuperPane;
	
	Point mOrigin; // Establishes this view's coordinate system (relative to location in superview)
	Rect mFrame; // The area (in local coordinates) in which subpanes may be drawn.
};
