/*	=================
 *	PedMenuFile.cpp
 *	=================
 */

#include "PedestalDebugging.h"

#include "PedMenuFile.hh"
#include "PedCommand.hh"

enum {
	idAppleMENU = 128, // menu ID = 1
	idFileMENU,
	idEditMENU
};


PedMenuFile::PedMenuFile()
: mNewCmd(NULL), mOpenCmd(NULL), mCloseCmd(NULL), mQuitCmd(NULL)
{
	GetFromResource(idFileMENU);
}

void
PedMenuFile::InstallCommand(PedCommand *inCmd, CmdCode inCode)
{
	switch (inCode) {
		case 'new ':
			mNewCmd = inCmd;
			break;
		case 'open':
			mOpenCmd = inCmd;
			break;
		case 'clos':
			mCloseCmd = inCmd;
			break;
		case 'quit':
			mQuitCmd = inCmd;
			break;
		default:
			break;
	}
}

void
PedMenuFile::DoMenuItem(short inItem)
{
	PedCommand *cmd;
	
	switch (inItem) {
		case 1:
			cmd = mNewCmd;
			break;
		case 2:
			cmd = mOpenCmd;
			break;
		case 3:
			cmd = mCloseCmd;
			break;
		case 5:
			cmd = mQuitCmd;
			break;
		default:
			cmd = NULL;
			break;
	}
	if (cmd)
		cmd->Execute();
}
