/*	==============
 *	V3DPanePort.hh
 *	==============
 *	
 *	Implemented by V3DPanePort.cc
 */

#pragma once

#include "PedPane.hh"

class C3DPort;
class C3DModel;

class V3DPanePort : public PedPane {
public:
	V3DPanePort(PedView &inSuperView, C3DModel &inModel);
	virtual ~V3DPanePort();
	
	virtual void Init();
	
	virtual void Open();
	virtual void Close();
	
	// Pane management
	virtual void Activate();
	virtual void Deactivate();
	virtual void Resize(short inWidth, short inHeight);
	
	// Event processing
	virtual void DispatchNullEvent(EventRecord &inEvent);
	virtual void DispatchClickEvent(EventRecord &inEvent);
	virtual void DispatchKey(EventRecord &inEvent);
	virtual void DoKey(char inChar);
	
protected:
	virtual void Draw();
	
	C3DPort *mPort;
};
